include \masm32\include\masm32rt.inc

.data?
startFlag	dd	?
numThreads	dd	?
.code

AxGetStackBottom	MACRO	thereg:REQ, theallocationsize
	ASSUME fs:NOTHING
	mov thereg, fs:[4]
	ifdif <theallocationsize>,<>
		sub thereg,theallocationsize
		add thereg,1024*32
	else
		sub thereg,(1024*1024-(1024*32))
	endif
	ASSUME fs:ERROR
	EXITM<thereg>
ENDM

; First parameter is pointer to a structure:
;	sampleControl	struct
;		aThreadNumber		dd	?
;		dwStackSizeEntered	dd	?
;	sampleControl	ends
; but in main function this structure created with simple pushs - to be local for each thread,
; and for simpleness
; Second parameter is a pointer to a DWORD, which is incremented with each successful recursive
; calling to the next level
		
RecursiveFunction	proc	dwParam1:DWORD, dwParam2:DWORD
	LOCAL bigbuffer[4000]:BYTE
	
	mov ecx,dwParam1	; get pointer to 2 DWORD - first is thread num, second is its stack size
	mov ecx,[ecx+4]

	cmp esp,AxGetStackBottom(eax,ecx)
	jbe @tooLowStackLevel
	
	mov ecx,dwParam2
	inc dword ptr [ecx]
	invoke RecursiveFunction,dwParam1,dwParam2
	@tooLowStackLevel:
	ret		
		
RecursiveFunction	endp

TheThread	proc	lpVoid:DWORD
	lock inc dword ptr numThreads	; lock for case if you too fastly enter values :P
	
	@@:
	invoke Sleep,100
	cmp startFlag,0
	jz @B
	
	mov ecx,lpVoid
	mov ecx,[ecx]
	invoke crt_printf,CTXT("Hi, this is thread #%u, starting recursive function...",10),ecx
	
	push 0
	invoke RecursiveFunction,lpVoid,esp
	
	mov eax,lpVoid
	mov eax,[eax]
	invoke crt_printf,CTXT("The thread #%u do %u recursive calls (limited to the stack size only)",10),eax
	lock dec dword ptr numThreads	; ...the same :P	
	pop edx
	ret
		
			
TheThread	endp


start:



invoke crt_printf,CTXT("Hi, this is testing program",10,"Enter a number of threads to test: ")
push eax
invoke crt_scanf,CTXT("%u"),esp
pop ebx
mov esi,1

push eax
@@:
invoke crt_printf,CTXT("Enter a stack size for the thread #%u: "),esi
push eax
invoke crt_scanf,CTXT("%u"),esp
mov ecx,[esp]	; thread stack size a second parameter of the structure
push esi	; thread number is a first parameter of the structure
mov edx,esp
push eax
invoke CreateThread,0,ecx,offset TheThread,edx,0,esp
pop eax
inc esi
cmp esi,ebx
jbe @B


or startFlag,1

@@:
invoke Sleep,100
cmp numThreads,0
jnz @B

lea esp,[esp+ebx*8+4]

invoke crt_printf,CTXT("All threads are finished, find and press [Any] key to exit..."),esi
invoke crt__getch

ret
end start
